/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-07 15:58:32 UTC)
 * on 2013-05-09 at 19:29:03 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.mirror.model;

/**
 * A list of Contacts representing contacts. This is the response from the server to GET requests on
 * the contacts collection.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Mirror API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ContactsListResponse extends com.google.api.client.json.GenericJson {

  /**
   * Contact list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Contact> items;

  /**
   * The type of resource. This is always mirror#contacts.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Contact list.
   * @return value or {@code null} for none
   */
  public java.util.List<Contact> getItems() {
    return items;
  }

  /**
   * Contact list.
   * @param items items or {@code null} for none
   */
  public ContactsListResponse setItems(java.util.List<Contact> items) {
    this.items = items;
    return this;
  }

  /**
   * The type of resource. This is always mirror#contacts.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The type of resource. This is always mirror#contacts.
   * @param kind kind or {@code null} for none
   */
  public ContactsListResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  @Override
  public ContactsListResponse set(String fieldName, Object value) {
    return (ContactsListResponse) super.set(fieldName, value);
  }

  @Override
  public ContactsListResponse clone() {
    return (ContactsListResponse) super.clone();
  }

}
