/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-07 15:58:32 UTC)
 * on 2013-05-09 at 19:29:03 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.mirror.model;

/**
 * A custom menu item that can be presented to the user by a timeline item.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Mirror API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class MenuItem extends com.google.api.client.json.GenericJson {

  /**
   * Controls the behavior when the user picks the menu option. Allowed values are: - CUSTOM -
   * Custom action set by the service. When the user selects this menuItem, the API triggers a
   * notification to your callbackUrl with the userActions.type set to CUSTOM and the
   * userActions.payload set to the ID of this menu item. This is the default value.  - Built-in
   * actions:   - REPLY - Initiate a reply to the timeline item using the voice recording UI. The
   * creator attribute must be set in the timeline item for this menu to be available.  - REPLY_ALL
   * - Same behavior as REPLY. The original timeline item's recipients will be added to the reply
   * item.  - DELETE - Delete the timeline item.  - SHARE - Share the timeline item with the
   * available contacts.  - READ_ALOUD - Read the timeline item's speakableText aloud; if this field
   * is not set, read the text field; if none of those fields are set, this menu item is ignored.
   * - VOICE_CALL - Initiate a phone call using the timeline item's creator.phone_number attribute
   * as recipient.  - NAVIGATE - Navigate to the timeline item's location.  - TOGGLE_PINNED - Toggle
   * the isPinned state of the timeline item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String action;

  /**
   * The ID for this menu item. This is generated by the application and is treated as an opaque
   * token.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * If set to true on a CUSTOM menu item, that item will be removed from the menu after it is
   * selected.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean removeWhenSelected;

  /**
   * For CUSTOM items, a list of values controlling the appearance of the menu item in each of its
   * states. A value for the DEFAULT state must be provided. If the PENDING or CONFIRMED states are
   * missing, they will not be shown.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<MenuValue> values;

  /**
   * Controls the behavior when the user picks the menu option. Allowed values are: - CUSTOM -
   * Custom action set by the service. When the user selects this menuItem, the API triggers a
   * notification to your callbackUrl with the userActions.type set to CUSTOM and the
   * userActions.payload set to the ID of this menu item. This is the default value.  - Built-in
   * actions:   - REPLY - Initiate a reply to the timeline item using the voice recording UI. The
   * creator attribute must be set in the timeline item for this menu to be available.  - REPLY_ALL
   * - Same behavior as REPLY. The original timeline item's recipients will be added to the reply
   * item.  - DELETE - Delete the timeline item.  - SHARE - Share the timeline item with the
   * available contacts.  - READ_ALOUD - Read the timeline item's speakableText aloud; if this field
   * is not set, read the text field; if none of those fields are set, this menu item is ignored.
   * - VOICE_CALL - Initiate a phone call using the timeline item's creator.phone_number attribute
   * as recipient.  - NAVIGATE - Navigate to the timeline item's location.  - TOGGLE_PINNED - Toggle
   * the isPinned state of the timeline item.
   * @return value or {@code null} for none
   */
  public java.lang.String getAction() {
    return action;
  }

  /**
   * Controls the behavior when the user picks the menu option. Allowed values are: - CUSTOM -
   * Custom action set by the service. When the user selects this menuItem, the API triggers a
   * notification to your callbackUrl with the userActions.type set to CUSTOM and the
   * userActions.payload set to the ID of this menu item. This is the default value.  - Built-in
   * actions:   - REPLY - Initiate a reply to the timeline item using the voice recording UI. The
   * creator attribute must be set in the timeline item for this menu to be available.  - REPLY_ALL
   * - Same behavior as REPLY. The original timeline item's recipients will be added to the reply
   * item.  - DELETE - Delete the timeline item.  - SHARE - Share the timeline item with the
   * available contacts.  - READ_ALOUD - Read the timeline item's speakableText aloud; if this field
   * is not set, read the text field; if none of those fields are set, this menu item is ignored.
   * - VOICE_CALL - Initiate a phone call using the timeline item's creator.phone_number attribute
   * as recipient.  - NAVIGATE - Navigate to the timeline item's location.  - TOGGLE_PINNED - Toggle
   * the isPinned state of the timeline item.
   * @param action action or {@code null} for none
   */
  public MenuItem setAction(java.lang.String action) {
    this.action = action;
    return this;
  }

  /**
   * The ID for this menu item. This is generated by the application and is treated as an opaque
   * token.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The ID for this menu item. This is generated by the application and is treated as an opaque
   * token.
   * @param id id or {@code null} for none
   */
  public MenuItem setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * If set to true on a CUSTOM menu item, that item will be removed from the menu after it is
   * selected.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getRemoveWhenSelected() {
    return removeWhenSelected;
  }

  /**
   * If set to true on a CUSTOM menu item, that item will be removed from the menu after it is
   * selected.
   * @param removeWhenSelected removeWhenSelected or {@code null} for none
   */
  public MenuItem setRemoveWhenSelected(java.lang.Boolean removeWhenSelected) {
    this.removeWhenSelected = removeWhenSelected;
    return this;
  }

  /**
   * For CUSTOM items, a list of values controlling the appearance of the menu item in each of its
   * states. A value for the DEFAULT state must be provided. If the PENDING or CONFIRMED states are
   * missing, they will not be shown.
   * @return value or {@code null} for none
   */
  public java.util.List<MenuValue> getValues() {
    return values;
  }

  /**
   * For CUSTOM items, a list of values controlling the appearance of the menu item in each of its
   * states. A value for the DEFAULT state must be provided. If the PENDING or CONFIRMED states are
   * missing, they will not be shown.
   * @param values values or {@code null} for none
   */
  public MenuItem setValues(java.util.List<MenuValue> values) {
    this.values = values;
    return this;
  }

  @Override
  public MenuItem set(String fieldName, Object value) {
    return (MenuItem) super.set(fieldName, value);
  }

  @Override
  public MenuItem clone() {
    return (MenuItem) super.clone();
  }

}
